#include <iostream>
#include "defs/defs.h"
#include "system/exception.h"
#include "osxsystem/singletons.h"

using namespace std;

//the mess of forward declarations...
extern void InitBase();

extern "C" {
	int cocoaInit();
}

//this might as well only exist for the sake of abstrating the different entry points ...
int main(int argc, char ** argv) {
	cocoaInit();
	sysBindSingletons();

	//why is this in system's lib?
	bool osxAdjustArguments(int &argc, char ** &argv);
	
	//remove the '-psn' from finder-launched applications
	osxAdjustArguments(argc, argv);

	//TODO - set up global implementing objects here
	//do this in all system's main()'s, or in some init location
	for (int i = 0; i < argc; i++) {
		osxSys.args.push_back(argv[i]);
	}

	//how do we mitigate the initialization occurring in main() in libsystem.dylib
	//yet subsequently calling InitBase, an unbound function, in libbase.dylib
	//how do we forward-reference functions that will not exist until linked with all else?
	try {
		InitBase();
	} catch (Exception &t) {
		cout << "caught an exception: " << t << endl;
		return 1;
	}
	return 0;
}
